{
  GridView
  Copyright (C) 1996-2002 by Berg
  All rights reserved.

  $id:GridView_dsgn.pas 12/25/2002 7:10:18 bn
}

unit GridView_prop;

interface

uses
	DesignIntf, DesignEditors, Classes, GridView, ColumnEditor, Forms, Columns;

type
  TGridViewComponentEditor = class(TDefaultEditor)
  public
    function GetVerb (Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure Edit; override;
    procedure EditProperty(const Prop: IProperty; var Continue: Boolean); override;
    procedure ExecuteVerb (Index: Integer); override;
  end;

  TColumnFormClass = class of TColumnForm;

  TColumnsProperty = class(TPropertyEditor)
  private
    function ShowForm(Owner: TPersistent): Boolean;
  protected
  	function GetColumnFormClass: TColumnFormClass; virtual;
  public
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
    procedure Edit; override;
  end;

implementation

uses
  Controls, Dialogs;

{ TGridViewComponentEditor }

procedure TGridViewComponentEditor.Edit;
begin
  inherited;

end;

procedure TGridViewComponentEditor.EditProperty(const Prop: IProperty; var Continue: Boolean);
begin
  inherited;
  if (Prop.GetName = 'Columns') then
  begin
    Continue := False;
    Prop.Edit; { call TColumnsProperty.Edit }
  end;
end;

procedure TGridViewComponentEditor.ExecuteVerb(Index: Integer);
begin
  inherited;
  case Index of
    0: Edit;
    1: ShowMessage('Copyright (C) 1996-2003 Berg Software'#13#10 +
                   'Version 1.9.5'#13#10 +
                   'http://www..bergsoftware.net/');
  end;
end;

function TGridViewComponentEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'Columns Editor...';
    1: Result := 'Version...';
  end;
end;

function TGridViewComponentEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

{ TColumnsProperty }

function TColumnsProperty.ShowForm(Owner: TPersistent): Boolean;
var
  i: Integer;
  Form: TCustomForm;
begin
  { try to locate form with
    same owner to show it again }
  Result := False;
  for i := 0 to Screen.FormCount - 1 do
  begin
    Form := Screen.Forms[i];
    if Form is TColumnForm then
      if TColumnForm(Form).Owner = Owner then
      begin
        Form.Show;
        if Form.WindowState = wsMinimized then Form.WindowState := wsNormal;
        Result := True;
        Exit;
      end;
  end;
end;

function TColumnsProperty.GetColumnFormClass: TColumnFormClass;
begin
  Result := TColumnForm;
end;

function TColumnsProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog, paReadOnly];
end;

function TColumnsProperty.GetValue: string;
begin
  Result := '(TColumns)';
end;

procedure TColumnsProperty.Edit;
var
  EditorForm: TColumnForm;
begin
  inherited;
  if not ShowForm(GetComponent(0)) then { form is already showed }
  begin
    EditorForm := GetColumnFormClass.Create(Application);
    try
      EditorForm.Owner := GetComponent(0);
      EditorForm.Designer := Self.Designer;
      EditorForm.WindowState := wsNormal;
      EditorForm.Show;
    except
      EditorForm.Free;
    end;
  end;
end;

end.
